#pragma once

#include "SC3DMC_Utils.h"
#include "SC3DMC_IndexedFaceSet.h"
#include "SC3DMC_TFANConnectivityDecoder.h"
#include "SC3DMC_SC3DMCHeader.h"

class TFANDecoder
{
	SC3DMCHeader * m_header;
	SC3DMC_IndexedFaceSet * m_ifs;	
	int m_vertexOrderPres;
	int m_triangleOrderPres;
	unsigned char m_meshType;
	unsigned int m_streamSize;

	DecoderStreamInfo m_streamInfo;

	int m_coordPredMode; 
	int m_texCoordPredMode; 
	int m_normalPredMode; 
	int m_colorPredMode; 
	int m_otherAttributesPredMode; 

	int m_binarizationMode;

public:
	inline void SetHeader(SC3DMCHeader * header) {m_header = header;}
	inline void SetIFS(SC3DMC_IndexedFaceSet * ifs){ m_ifs = ifs;}
	inline SC3DMC_IndexedFaceSet * GetIFS(){ return m_ifs;}
	inline unsigned int GetStreamSize(){ return m_streamSize;}
	
	
	void DecodeTFANData(unsigned char * &compressedStream);
	TFANDecoder(): m_vertexOrderPres(0), m_triangleOrderPres(0), m_ifs(NULL), m_meshType(0), m_streamSize(0){};

	~TFANDecoder(void){};
};
