#pragma once
#include "SC3DMC_IndexedFaceSet.h"
#include "SC3DMC_TFANConnectivityEncoder.h"
#include "SC3DMC_TFANConnectivityDecoder.h"
#include "SC3DMC_EncodingParameter.h"
#include "SC3DMC_Utils.h"

class TFANEncoder
{
	SC3DMC_IndexedFaceSet * m_ifs;
	EncodingParams * m_params;
	EncoderStreamInfo m_streamInfo;

public:
	inline void SetIFS(SC3DMC_IndexedFaceSet * ifs){ m_ifs = ifs;}
	inline void SetParams(EncodingParams * params){ m_params = params;}

	// This function is called before encode
	// It should return the nombre of bytes to be allocated for the compressed stream
	unsigned int GetEstimatedCompressedStreamSize() { return 50000000;};

	
	//	Writes the main stream
	void EncodeDataBuffer(unsigned char * compressedStream, unsigned int & compressedStreamSize);


	TFANEncoder(void):m_ifs(NULL){};
	~TFANEncoder(void){};
};
